<?php

namespace VoorraadApiV5;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'authentication' => '\\VoorraadApiV5\\StructType\\Authentication',
            'applicationError' => '\\VoorraadApiV5\\StructType\\ApplicationError',
            'AdresRecV5' => '\\VoorraadApiV5\\StructType\\AdresRecV5',
            'ArtikelgroepRecV5' => '\\VoorraadApiV5\\StructType\\ArtikelgroepRecV5',
            'ArtikelPrijzenRecV5' => '\\VoorraadApiV5\\StructType\\ArtikelPrijzenRecV5',
            'ArtikelSamenstellingRecV5' => '\\VoorraadApiV5\\StructType\\ArtikelSamenstellingRecV5',
            'ArtikelStaffelRecV5' => '\\VoorraadApiV5\\StructType\\ArtikelStaffelRecV5',
            'ArtikelVrijeVeldenRecV5' => '\\VoorraadApiV5\\StructType\\ArtikelVrijeVeldenRecV5',
            'BetaalRecV5' => '\\VoorraadApiV5\\StructType\\BetaalRecV5',
            'BetalingsconditieRecV5' => '\\VoorraadApiV5\\StructType\\BetalingsconditieRecV5',
            'DownloadLinkRecV5' => '\\VoorraadApiV5\\StructType\\DownloadLinkRecV5',
            'FondsGroepRecV5' => '\\VoorraadApiV5\\StructType\\FondsGroepRecV5',
            'FondsRecV5' => '\\VoorraadApiV5\\StructType\\FondsRecV5',
            'LeverantieregelRecV5' => '\\VoorraadApiV5\\StructType\\LeverantieregelRecV5',
            'MagazijnRecV5' => '\\VoorraadApiV5\\StructType\\MagazijnRecV5',
            'OrderregelRecV5' => '\\VoorraadApiV5\\StructType\\OrderregelRecV5',
            'OrdersoortRecV5' => '\\VoorraadApiV5\\StructType\\OrdersoortRecV5',
            'OrderAfleverRecV5' => '\\VoorraadApiV5\\StructType\\OrderAfleverRecV5',
            'PublicatieCoderingenRecV5' => '\\VoorraadApiV5\\StructType\\PublicatieCoderingenRecV5',
            'RechthebbendeRecV5' => '\\VoorraadApiV5\\StructType\\RechthebbendeRecV5',
            'RechthebbendeVrijeVeldenV5' => '\\VoorraadApiV5\\StructType\\RechthebbendeVrijeVeldenV5',
            'RelatieArtikelRecV5' => '\\VoorraadApiV5\\StructType\\RelatieArtikelRecV5',
            'RelatieLeverantieregelRecV5' => '\\VoorraadApiV5\\StructType\\RelatieLeverantieregelRecV5',
            'VerkooporderregelInfoRecV5' => '\\VoorraadApiV5\\StructType\\VerkooporderregelInfoRecV5',
            'VerkooporderregelLevRecV5' => '\\VoorraadApiV5\\StructType\\VerkooporderregelLevRecV5',
            'VerkooporderInfoRecV5' => '\\VoorraadApiV5\\StructType\\VerkooporderInfoRecV5',
            'VerschijningsvormRecV5' => '\\VoorraadApiV5\\StructType\\VerschijningsvormRecV5',
            'VerzendwijzeRecV5' => '\\VoorraadApiV5\\StructType\\VerzendwijzeRecV5',
            'VoorraadArtikelRecV5' => '\\VoorraadApiV5\\StructType\\VoorraadArtikelRecV5',
            'VoorraadInfoMagazijnRecV5' => '\\VoorraadApiV5\\StructType\\VoorraadInfoMagazijnRecV5',
            'VoorraadInfoRecV5' => '\\VoorraadApiV5\\StructType\\VoorraadInfoRecV5',
            'VrijeVeldenVrdRecV5' => '\\VoorraadApiV5\\StructType\\VrijeVeldenVrdRecV5',
            'VrijCodeveldRecV5' => '\\VoorraadApiV5\\StructType\\VrijCodeveldRecV5',
            'VrijCodeveldVrdRecV5' => '\\VoorraadApiV5\\StructType\\VrijCodeveldVrdRecV5',
            'VrijDatumveldRecV5' => '\\VoorraadApiV5\\StructType\\VrijDatumveldRecV5',
            'VrijDatumveldVrdRecV5' => '\\VoorraadApiV5\\StructType\\VrijDatumveldVrdRecV5',
            'VrijTekstveldRecV5' => '\\VoorraadApiV5\\StructType\\VrijTekstveldRecV5',
            'VrijTekstveldVrdRecV5' => '\\VoorraadApiV5\\StructType\\VrijTekstveldVrdRecV5',
            'ArtikelPrijzenTableV5' => '\\VoorraadApiV5\\StructType\\ArtikelPrijzenTableV5',
            'ArtikelSamenstellingTableV5' => '\\VoorraadApiV5\\StructType\\ArtikelSamenstellingTableV5',
            'ArtikelStaffelTableV5' => '\\VoorraadApiV5\\StructType\\ArtikelStaffelTableV5',
            'DownloadLinkTableV5' => '\\VoorraadApiV5\\StructType\\DownloadLinkTableV5',
            'FondsGroepTableV5' => '\\VoorraadApiV5\\StructType\\FondsGroepTableV5',
            'FondsTableV5' => '\\VoorraadApiV5\\StructType\\FondsTableV5',
            'LeverantieregeltableV5' => '\\VoorraadApiV5\\StructType\\LeverantieregeltableV5',
            'OrderregeltableV5' => '\\VoorraadApiV5\\StructType\\OrderregeltableV5',
            'OrdersoorttableV5' => '\\VoorraadApiV5\\StructType\\OrdersoorttableV5',
            'PublicatieCoderingenTableV5' => '\\VoorraadApiV5\\StructType\\PublicatieCoderingenTableV5',
            'RechthebbendeTableV5' => '\\VoorraadApiV5\\StructType\\RechthebbendeTableV5',
            'RelatieArtikeltableV5' => '\\VoorraadApiV5\\StructType\\RelatieArtikeltableV5',
            'RelatieLeverantieregeltblV5' => '\\VoorraadApiV5\\StructType\\RelatieLeverantieregeltblV5',
            'VerkooporderregelInfoTabV5' => '\\VoorraadApiV5\\StructType\\VerkooporderregelInfoTabV5',
            'VerkooporderregelLevTabV5' => '\\VoorraadApiV5\\StructType\\VerkooporderregelLevTabV5',
            'VerkooporderInfoTabV5' => '\\VoorraadApiV5\\StructType\\VerkooporderInfoTabV5',
            'VerschijningsvormtableV5' => '\\VoorraadApiV5\\StructType\\VerschijningsvormtableV5',
            'VerzendwijzetableV5' => '\\VoorraadApiV5\\StructType\\VerzendwijzetableV5',
            'VoorraadArtikeltableV5' => '\\VoorraadApiV5\\StructType\\VoorraadArtikeltableV5',
            'VoorraadInfoMagazijnTabV5' => '\\VoorraadApiV5\\StructType\\VoorraadInfoMagazijnTabV5',
            'VoorraadInfoTableV5' => '\\VoorraadApiV5\\StructType\\VoorraadInfoTableV5',
            'getFondsGroepenRequest' => '\\VoorraadApiV5\\StructType\\GetFondsGroepenRequest',
            'getFondsGroepenResponse' => '\\VoorraadApiV5\\StructType\\GetFondsGroepenResponse',
            'getFondsenPerGroepRequest' => '\\VoorraadApiV5\\StructType\\GetFondsenPerGroepRequest',
            'getFondsenPerGroepResponse' => '\\VoorraadApiV5\\StructType\\GetFondsenPerGroepResponse',
            'getArtikelInfoRequest' => '\\VoorraadApiV5\\StructType\\GetArtikelInfoRequest',
            'getArtikelInfoResponse' => '\\VoorraadApiV5\\StructType\\GetArtikelInfoResponse',
            'getArtikelLijstInfoRequest' => '\\VoorraadApiV5\\StructType\\GetArtikelLijstInfoRequest',
            'getArtikelLijstInfoResponse' => '\\VoorraadApiV5\\StructType\\GetArtikelLijstInfoResponse',
            'getVoorraadInfoRequest' => '\\VoorraadApiV5\\StructType\\GetVoorraadInfoRequest',
            'getVoorraadInfoResponse' => '\\VoorraadApiV5\\StructType\\GetVoorraadInfoResponse',
            'getVoorraadLijstInfoRequest' => '\\VoorraadApiV5\\StructType\\GetVoorraadLijstInfoRequest',
            'getVoorraadLijstInfoResponse' => '\\VoorraadApiV5\\StructType\\GetVoorraadLijstInfoResponse',
            'createVerkoopOrderRequest' => '\\VoorraadApiV5\\StructType\\CreateVerkoopOrderRequest',
            'createVerkoopOrderResponse' => '\\VoorraadApiV5\\StructType\\CreateVerkoopOrderResponse',
            'getVerkoopOrdersRequest' => '\\VoorraadApiV5\\StructType\\GetVerkoopOrdersRequest',
            'getVerkoopOrdersResponse' => '\\VoorraadApiV5\\StructType\\GetVerkoopOrdersResponse',
            'orderEBooksRequest' => '\\VoorraadApiV5\\StructType\\OrderEBooksRequest',
            'orderEBooksResponse' => '\\VoorraadApiV5\\StructType\\OrderEBooksResponse',
            'getOrdersoortenRequest' => '\\VoorraadApiV5\\StructType\\GetOrdersoortenRequest',
            'getOrdersoortenResponse' => '\\VoorraadApiV5\\StructType\\GetOrdersoortenResponse',
            'getVerzendwijzenRequest' => '\\VoorraadApiV5\\StructType\\GetVerzendwijzenRequest',
            'getVerzendwijzenResponse' => '\\VoorraadApiV5\\StructType\\GetVerzendwijzenResponse',
            'getRelatieArtikelPrijsRequest' => '\\VoorraadApiV5\\StructType\\GetRelatieArtikelPrijsRequest',
            'getRelatieArtikelPrijsResponse' => '\\VoorraadApiV5\\StructType\\GetRelatieArtikelPrijsResponse',
            'getVerschijningsvormenRequest' => '\\VoorraadApiV5\\StructType\\GetVerschijningsvormenRequest',
            'getVerschijningsvormenResponse' => '\\VoorraadApiV5\\StructType\\GetVerschijningsvormenResponse',
            'getRelatieArtikelenRequest' => '\\VoorraadApiV5\\StructType\\GetRelatieArtikelenRequest',
            'getRelatieArtikelenResponse' => '\\VoorraadApiV5\\StructType\\GetRelatieArtikelenResponse',
            'getLeverantiesRequest' => '\\VoorraadApiV5\\StructType\\GetLeverantiesRequest',
            'getLeverantiesResponse' => '\\VoorraadApiV5\\StructType\\GetLeverantiesResponse',
            'createArtikelRequest' => '\\VoorraadApiV5\\StructType\\CreateArtikelRequest',
            'createArtikelResponse' => '\\VoorraadApiV5\\StructType\\CreateArtikelResponse',
            'updateArtikelRequest' => '\\VoorraadApiV5\\StructType\\UpdateArtikelRequest',
            'updateArtikelResponse' => '\\VoorraadApiV5\\StructType\\UpdateArtikelResponse',
            'createLeverantieRequest' => '\\VoorraadApiV5\\StructType\\CreateLeverantieRequest',
            'createLeverantieResponse' => '\\VoorraadApiV5\\StructType\\CreateLeverantieResponse',
        );
    }
}
