<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArtikelSamenstellingTableV5 StructType
 * Meta informations extracted from the WSDL
 * - documentation: lijst met artikelen waar het artikel uit is samengesteld
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class ArtikelSamenstellingTableV5 extends AbstractStructBase
{
    /**
     * The artikelSamenstelling
     * Meta informations extracted from the WSDL
     * - documentation: Samengesteld_uit_artikel
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5[]
     */
    public $artikelSamenstelling;
    /**
     * Constructor method for ArtikelSamenstellingTableV5
     * @uses ArtikelSamenstellingTableV5::setArtikelSamenstelling()
     * @param \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5[] $artikelSamenstelling
     */
    public function __construct(array $artikelSamenstelling = array())
    {
        $this
            ->setArtikelSamenstelling($artikelSamenstelling);
    }
    /**
     * Get artikelSamenstelling value
     * @return \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5[]|null
     */
    public function getArtikelSamenstelling()
    {
        return $this->artikelSamenstelling;
    }
    /**
     * This method is responsible for validating the values passed to the setArtikelSamenstelling method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArtikelSamenstelling method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArtikelSamenstellingForArrayConstraintsFromSetArtikelSamenstelling(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $artikelSamenstellingTableV5ArtikelSamenstellingItem) {
            // validation for constraint: itemType
            if (!$artikelSamenstellingTableV5ArtikelSamenstellingItem instanceof \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5) {
                $invalidValues[] = is_object($artikelSamenstellingTableV5ArtikelSamenstellingItem) ? get_class($artikelSamenstellingTableV5ArtikelSamenstellingItem) : sprintf('%s(%s)', gettype($artikelSamenstellingTableV5ArtikelSamenstellingItem), var_export($artikelSamenstellingTableV5ArtikelSamenstellingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The artikelSamenstelling property can only contain items of type \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set artikelSamenstelling value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5[] $artikelSamenstelling
     * @return \VoorraadApiV5\StructType\ArtikelSamenstellingTableV5
     */
    public function setArtikelSamenstelling(array $artikelSamenstelling = array())
    {
        // validation for constraint: array
        if ('' !== ($artikelSamenstellingArrayErrorMessage = self::validateArtikelSamenstellingForArrayConstraintsFromSetArtikelSamenstelling($artikelSamenstelling))) {
            throw new \InvalidArgumentException($artikelSamenstellingArrayErrorMessage, __LINE__);
        }
        $this->artikelSamenstelling = $artikelSamenstelling;
        return $this;
    }
    /**
     * Add item to artikelSamenstelling value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5 $item
     * @return \VoorraadApiV5\StructType\ArtikelSamenstellingTableV5
     */
    public function addToArtikelSamenstelling(\VoorraadApiV5\StructType\ArtikelSamenstellingRecV5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5) {
            throw new \InvalidArgumentException(sprintf('The artikelSamenstelling property can only contain items of type \VoorraadApiV5\StructType\ArtikelSamenstellingRecV5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->artikelSamenstelling[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\ArtikelSamenstellingTableV5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
