<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createArtikelResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: error522: Op basis van de opgegeven code is geen BTW-code gevonden | error521: Op basis van de opgegeven code is geen artikelgroep gevonden
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class CreateArtikelResponse extends AbstractStructBase
{
    /**
     * The requestTag
     * Meta informations extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The isNieuwArtikel
     * Meta informations extracted from the WSDL
     * - documentation: Indicatie dat het artikel nieuw aangemaakt is. true: Het artikel is nieuw aangemaakt, false: Het artikel bestond al
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $isNieuwArtikel;
    /**
     * The artikel
     * Meta informations extracted from the WSDL
     * - documentation: De gegevens van het (nieuwe of bestaande) artikel
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \VoorraadApiV5\StructType\VoorraadArtikelRecV5
     */
    public $artikel;
    /**
     * Constructor method for createArtikelResponse
     * @uses CreateArtikelResponse::setRequestTag()
     * @uses CreateArtikelResponse::setIsNieuwArtikel()
     * @uses CreateArtikelResponse::setArtikel()
     * @param string $requestTag
     * @param bool $isNieuwArtikel
     * @param \VoorraadApiV5\StructType\VoorraadArtikelRecV5 $artikel
     */
    public function __construct($requestTag = null, $isNieuwArtikel = null, \VoorraadApiV5\StructType\VoorraadArtikelRecV5 $artikel = null)
    {
        $this
            ->setRequestTag($requestTag)
            ->setIsNieuwArtikel($isNieuwArtikel)
            ->setArtikel($artikel);
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \VoorraadApiV5\StructType\CreateArtikelResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get isNieuwArtikel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsNieuwArtikel()
    {
        return isset($this->isNieuwArtikel) ? $this->isNieuwArtikel : null;
    }
    /**
     * Set isNieuwArtikel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isNieuwArtikel
     * @return \VoorraadApiV5\StructType\CreateArtikelResponse
     */
    public function setIsNieuwArtikel($isNieuwArtikel = null)
    {
        // validation for constraint: boolean
        if (!is_null($isNieuwArtikel) && !is_bool($isNieuwArtikel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isNieuwArtikel, true), gettype($isNieuwArtikel)), __LINE__);
        }
        if (is_null($isNieuwArtikel) || (is_array($isNieuwArtikel) && empty($isNieuwArtikel))) {
            unset($this->isNieuwArtikel);
        } else {
            $this->isNieuwArtikel = $isNieuwArtikel;
        }
        return $this;
    }
    /**
     * Get artikel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \VoorraadApiV5\StructType\VoorraadArtikelRecV5|null
     */
    public function getArtikel()
    {
        return isset($this->artikel) ? $this->artikel : null;
    }
    /**
     * Set artikel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \VoorraadApiV5\StructType\VoorraadArtikelRecV5 $artikel
     * @return \VoorraadApiV5\StructType\CreateArtikelResponse
     */
    public function setArtikel(\VoorraadApiV5\StructType\VoorraadArtikelRecV5 $artikel = null)
    {
        if (is_null($artikel) || (is_array($artikel) && empty($artikel))) {
            unset($this->artikel);
        } else {
            $this->artikel = $artikel;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\CreateArtikelResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
