<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getVoorraadLijstInfoResponse StructType
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class GetVoorraadLijstInfoResponse extends AbstractStructBase
{
    /**
     * The requestTag
     * Meta informations extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The voorraadLijst
     * Meta informations extracted from the WSDL
     * - documentation: De voorraad informatie lijst
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \VoorraadApiV5\StructType\VoorraadInfoTableV5
     */
    public $voorraadLijst;
    /**
     * Constructor method for getVoorraadLijstInfoResponse
     * @uses GetVoorraadLijstInfoResponse::setRequestTag()
     * @uses GetVoorraadLijstInfoResponse::setVoorraadLijst()
     * @param string $requestTag
     * @param \VoorraadApiV5\StructType\VoorraadInfoTableV5 $voorraadLijst
     */
    public function __construct($requestTag = null, \VoorraadApiV5\StructType\VoorraadInfoTableV5 $voorraadLijst = null)
    {
        $this
            ->setRequestTag($requestTag)
            ->setVoorraadLijst($voorraadLijst);
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \VoorraadApiV5\StructType\GetVoorraadLijstInfoResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get voorraadLijst value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \VoorraadApiV5\StructType\VoorraadInfoTableV5|null
     */
    public function getVoorraadLijst()
    {
        return isset($this->voorraadLijst) ? $this->voorraadLijst : null;
    }
    /**
     * Set voorraadLijst value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \VoorraadApiV5\StructType\VoorraadInfoTableV5 $voorraadLijst
     * @return \VoorraadApiV5\StructType\GetVoorraadLijstInfoResponse
     */
    public function setVoorraadLijst(\VoorraadApiV5\StructType\VoorraadInfoTableV5 $voorraadLijst = null)
    {
        if (is_null($voorraadLijst) || (is_array($voorraadLijst) && empty($voorraadLijst))) {
            unset($this->voorraadLijst);
        } else {
            $this->voorraadLijst = $voorraadLijst;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\GetVoorraadLijstInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
