<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VerschijningsvormtableV5 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Lijst met beschikbare verschijningsvormen
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class VerschijningsvormtableV5 extends AbstractStructBase
{
    /**
     * The verschijningsvorm
     * Meta informations extracted from the WSDL
     * - documentation: verschijningsvormRec
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \VoorraadApiV5\StructType\VerschijningsvormRecV5[]
     */
    public $verschijningsvorm;
    /**
     * Constructor method for VerschijningsvormtableV5
     * @uses VerschijningsvormtableV5::setVerschijningsvorm()
     * @param \VoorraadApiV5\StructType\VerschijningsvormRecV5[] $verschijningsvorm
     */
    public function __construct(array $verschijningsvorm = array())
    {
        $this
            ->setVerschijningsvorm($verschijningsvorm);
    }
    /**
     * Get verschijningsvorm value
     * @return \VoorraadApiV5\StructType\VerschijningsvormRecV5[]|null
     */
    public function getVerschijningsvorm()
    {
        return $this->verschijningsvorm;
    }
    /**
     * This method is responsible for validating the values passed to the setVerschijningsvorm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVerschijningsvorm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVerschijningsvormForArrayConstraintsFromSetVerschijningsvorm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $verschijningsvormtableV5VerschijningsvormItem) {
            // validation for constraint: itemType
            if (!$verschijningsvormtableV5VerschijningsvormItem instanceof \VoorraadApiV5\StructType\VerschijningsvormRecV5) {
                $invalidValues[] = is_object($verschijningsvormtableV5VerschijningsvormItem) ? get_class($verschijningsvormtableV5VerschijningsvormItem) : sprintf('%s(%s)', gettype($verschijningsvormtableV5VerschijningsvormItem), var_export($verschijningsvormtableV5VerschijningsvormItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The verschijningsvorm property can only contain items of type \VoorraadApiV5\StructType\VerschijningsvormRecV5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set verschijningsvorm value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\VerschijningsvormRecV5[] $verschijningsvorm
     * @return \VoorraadApiV5\StructType\VerschijningsvormtableV5
     */
    public function setVerschijningsvorm(array $verschijningsvorm = array())
    {
        // validation for constraint: array
        if ('' !== ($verschijningsvormArrayErrorMessage = self::validateVerschijningsvormForArrayConstraintsFromSetVerschijningsvorm($verschijningsvorm))) {
            throw new \InvalidArgumentException($verschijningsvormArrayErrorMessage, __LINE__);
        }
        $this->verschijningsvorm = $verschijningsvorm;
        return $this;
    }
    /**
     * Add item to verschijningsvorm value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\VerschijningsvormRecV5 $item
     * @return \VoorraadApiV5\StructType\VerschijningsvormtableV5
     */
    public function addToVerschijningsvorm(\VoorraadApiV5\StructType\VerschijningsvormRecV5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \VoorraadApiV5\StructType\VerschijningsvormRecV5) {
            throw new \InvalidArgumentException(sprintf('The verschijningsvorm property can only contain items of type \VoorraadApiV5\StructType\VerschijningsvormRecV5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->verschijningsvorm[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\VerschijningsvormtableV5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
