<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VoorraadArtikeltableV5 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Lijst met beschikbare voorraad artikelen
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class VoorraadArtikeltableV5 extends AbstractStructBase
{
    /**
     * The voorraadArtikel
     * Meta informations extracted from the WSDL
     * - documentation: VoorraadArtikelRec
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \VoorraadApiV5\StructType\VoorraadArtikelRecV5[]
     */
    public $voorraadArtikel;
    /**
     * Constructor method for VoorraadArtikeltableV5
     * @uses VoorraadArtikeltableV5::setVoorraadArtikel()
     * @param \VoorraadApiV5\StructType\VoorraadArtikelRecV5[] $voorraadArtikel
     */
    public function __construct(array $voorraadArtikel = array())
    {
        $this
            ->setVoorraadArtikel($voorraadArtikel);
    }
    /**
     * Get voorraadArtikel value
     * @return \VoorraadApiV5\StructType\VoorraadArtikelRecV5[]|null
     */
    public function getVoorraadArtikel()
    {
        return $this->voorraadArtikel;
    }
    /**
     * This method is responsible for validating the values passed to the setVoorraadArtikel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoorraadArtikel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoorraadArtikelForArrayConstraintsFromSetVoorraadArtikel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $voorraadArtikeltableV5VoorraadArtikelItem) {
            // validation for constraint: itemType
            if (!$voorraadArtikeltableV5VoorraadArtikelItem instanceof \VoorraadApiV5\StructType\VoorraadArtikelRecV5) {
                $invalidValues[] = is_object($voorraadArtikeltableV5VoorraadArtikelItem) ? get_class($voorraadArtikeltableV5VoorraadArtikelItem) : sprintf('%s(%s)', gettype($voorraadArtikeltableV5VoorraadArtikelItem), var_export($voorraadArtikeltableV5VoorraadArtikelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The voorraadArtikel property can only contain items of type \VoorraadApiV5\StructType\VoorraadArtikelRecV5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set voorraadArtikel value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\VoorraadArtikelRecV5[] $voorraadArtikel
     * @return \VoorraadApiV5\StructType\VoorraadArtikeltableV5
     */
    public function setVoorraadArtikel(array $voorraadArtikel = array())
    {
        // validation for constraint: array
        if ('' !== ($voorraadArtikelArrayErrorMessage = self::validateVoorraadArtikelForArrayConstraintsFromSetVoorraadArtikel($voorraadArtikel))) {
            throw new \InvalidArgumentException($voorraadArtikelArrayErrorMessage, __LINE__);
        }
        $this->voorraadArtikel = $voorraadArtikel;
        return $this;
    }
    /**
     * Add item to voorraadArtikel value
     * @throws \InvalidArgumentException
     * @param \VoorraadApiV5\StructType\VoorraadArtikelRecV5 $item
     * @return \VoorraadApiV5\StructType\VoorraadArtikeltableV5
     */
    public function addToVoorraadArtikel(\VoorraadApiV5\StructType\VoorraadArtikelRecV5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \VoorraadApiV5\StructType\VoorraadArtikelRecV5) {
            throw new \InvalidArgumentException(sprintf('The voorraadArtikel property can only contain items of type \VoorraadApiV5\StructType\VoorraadArtikelRecV5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->voorraadArtikel[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\VoorraadArtikeltableV5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
