<?php

namespace VoorraadApiV5\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VrijTekstveldRecV5 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Vrij tekstveld
 * @subpackage Structs
 * @date 20190723
 * @package VoorraadApiV5
 */
class VrijTekstveldRecV5 extends AbstractStructBase
{
    /**
     * The label
     * Meta informations extracted from the WSDL
     * - documentation: Label voor het vrije veld
     * - base: xsd:string
     * - maxLength: 20
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $label;
    /**
     * The waarde
     * Meta informations extracted from the WSDL
     * - documentation: Waarde van het vrije veld
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $waarde;
    /**
     * Constructor method for VrijTekstveldRecV5
     * @uses VrijTekstveldRecV5::setLabel()
     * @uses VrijTekstveldRecV5::setWaarde()
     * @param string $label
     * @param string $waarde
     */
    public function __construct($label = null, $waarde = null)
    {
        $this
            ->setLabel($label)
            ->setWaarde($waarde);
    }
    /**
     * Get label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->label) ? $this->label : null;
    }
    /**
     * Set label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \VoorraadApiV5\StructType\VrijTekstveldRecV5
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        // validation for constraint: maxLength(20)
        if (!is_null($label) && mb_strlen($label) > 20) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 20', mb_strlen($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->label);
        } else {
            $this->label = $label;
        }
        return $this;
    }
    /**
     * Get waarde value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWaarde()
    {
        return isset($this->waarde) ? $this->waarde : null;
    }
    /**
     * Set waarde value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $waarde
     * @return \VoorraadApiV5\StructType\VrijTekstveldRecV5
     */
    public function setWaarde($waarde = null)
    {
        // validation for constraint: string
        if (!is_null($waarde) && !is_string($waarde)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($waarde, true), gettype($waarde)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($waarde) && mb_strlen($waarde) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($waarde)), __LINE__);
        }
        if (is_null($waarde) || (is_array($waarde) && empty($waarde))) {
            unset($this->waarde);
        } else {
            $this->waarde = $waarde;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \VoorraadApiV5\StructType\VrijTekstveldRecV5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
